Subject: Re: [PATCH v2 2/2] completion: add a GIT_COMPLETION_SHOW_ALL_COMMANDS

From: SZEDER Gábor <[email-masked]>
Date: Sun, 6 Feb 2022 23:47:40 +0100

On Sun, Feb 06, 2022 at 12:09:35PM -0800, Junio C Hamano wrote:
> SZEDER Gábor <[email-masked]> writes:
> 
> > To complete only rarely used plumbing commands in a non-intrusive way,
> > in my experience, it's best to first attempt to complete only
> > porcelains and aliases, and fall back to complete all commands,
> > plumbing included, only when no porcelains match the current word to
> > be completed.  E.g.:
> >
> >   $ git d<TAB>
> >   describe   diff   difftool
> >   $ git diff-<TAB>
> >   diff-files   diff-index   diff-tree
> 
> So after getting
> 
>     $ git diff<TAB>
>     diff difftool
> 
> you _have_ to know, if you are not happy with these two, that the
> next letter in the name of the command you forgot is a dash,

Yeah, it can only save a couple of keystrokes, but it's not really
useful when you want to use it to jog your memory.  I naively assumed
that if you use plumbing, then you know what you are doing and which
command you want to execute :)

> to be
> able to say
> 
>     $ git diff-<TAB>
> 
> which is a bit unfortunate, but I agree that it is much nicer than
> getting all the plumbing when trying to complete "git d<TAB>".
> 
> I wonder if we can do better, and teach the completion logic an
> ability to say this: "I gave 'diff and difftool' after being asked
> for 'git diff<TAB>' and then the user is asking the same again
> without choosing either. Perhaps I should add less frequent one to
> the mix"?
> 
> I.e. the end-user session may look like
> 
>     $ git diff<TAB>
>     diff difftool
>     $ git diff<TAB>
>     diff difftool diff-files diff-index diff-tree
> 
> ?

Hrm, interesting, but dunno.  When completing commands in __git_main()
we could save the current word to be completed in a variable, and when
completing commands the next time we could check whether the current
word is still the same, and then include plumbing as well.  However,
when the current word can't be uniquely completed, then we have to
press TAB twice to get the list of possible completion, so we have to
preserve the last two current words, and only list plumbing when both
match.

  ---   >8   ---

diff --git a/contrib/completion/git-completion.bash b/contrib/completion/git-completion.bash
index 377d6c5494..cda6b48c4e 100644
--- a/contrib/completion/git-completion.bash
+++ b/contrib/completion/git-completion.bash
@@ -3455,8 +3455,17 @@ __git_main ()
 			then
 				__gitcomp "$GIT_TESTING_PORCELAIN_COMMAND_LIST"
 			else
-				__gitcomp "$(__git --list-cmds=list-mainporcelain,others,nohelpers,alias,list-complete,config)"
+				echo >>/tmp/COMPLOG "__git_main() cur: '$cur' last: '$__git_last_command_cur' last2: '$__git_last_command_cur2'"
+				if test "$cur" = "$__git_last_command_cur" &&
+				   test "$cur" = "$__git_last_command_cur2"
+				then
+					__gitcomp "$(__git --list-cmds=main,others,nohelpers,alias,list-complete)"
+				else
+					__gitcomp "$(__git --list-cmds=list-mainporcelain,others,nohelpers,alias,list-complete,config)"
+				fi
 			fi
+			__git_last_command_cur2=$__git_last_command_cur
+			__git_last_command_cur=$cur
 			;;
 		esac
 		return

  ---   8<   ---

Superficial testing shows that it appears to work in common cases, but
we'll have to think it through when and how to clear these variables.
E.g.:

  $ git d<TAB><TAB>
  describe   diff   difftool
  # Oh, but I wanted to disable the pager
  $ git --no-p<TAB>
  # this completes the option uniquely
  $ git --no-pager d<TAB><TAB>
  daemon     diff         diff-index   diff-tree
  describe   diff-files   difftool

I think here it should list only porcelains, but because both those
last_cur variables still contain 'd', it lists plumbing as well.

And, of course, 'git <TAB><TAB>' in a newly started terminal should
list only porcelains, but it lists plumbing as well.